//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%38CD1AF57320.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%38CD1AF57320.cm

//## begin module%38CD1AF57320.cp preserve=no
//## end module%38CD1AF57320.cp

//## Module: XSstream%38CD1AF57320; Package specification
//## Subsystem: XSUtil::Utils%3777E01D9D80
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Utils/XSstream.h

#ifndef XS_STREAM_H
#define XS_STREAM_H 1

//## begin module%38CD1AF57320.additionalIncludes preserve=no
//## end module%38CD1AF57320.additionalIncludes

//## begin module%38CD1AF57320.includes preserve=yes
#include <cstdio>
//## end module%38CD1AF57320.includes

// iostream
#include <iostream>
// vector
#include <vector>
// Error
#include <XSUtil/Error/Error.h>

class XSstreambuf;
class XSstream;
class XSchannel;

//## begin module%38CD1AF57320.declarations preserve=no
//## end module%38CD1AF57320.declarations

//## begin module%38CD1AF57320.additionalDeclarations preserve=yes
using std::string;

const unsigned int bufSize=1024;
extern const size_t NORM_OUTPUT;
//## end module%38CD1AF57320.additionalDeclarations


//## Class: XSstreambuf%3898889BE8F0
//## Category: XSUtil::Utils%370B67146E50
//## Subsystem: XSUtil::Utils%3777E01D9D80
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class XSstreambuf : public std::streambuf  //## Inherits: <unnamed>%389888B3C7F0
{
  public:
    //## Constructors (generated)
      XSstreambuf();

    //## Constructors (specified)
      //## Operation: XSstreambuf%38988F77ED60
      //	Tcl streambuf for input/output. Contains a tcl "channel",
      //	which contains the read/write methods, and overloads
      //	sync and overflow methods for the buffer.
      XSstreambuf (XSchannel* chan, std::streamsize bufferLen = 0);

    //## Destructor (generated)
      virtual ~XSstreambuf();


    //## Other Operations (specified)
      //## Operation: setChannel%38B6A13B1A18
      void setChannel (XSchannel* channel, std::streamsize bufferLen, XSstream* parent);

      //## Operation: setChannelPrompt%38D2B19AD918
      void setChannelPrompt (const std::string& ps);

      //## Operation: setChannelPrompt%38E2753507F8
      void setChannelPrompt (const std::string& ps, const std::vector<std::string>& prompts, const std::vector<std::string>& infos);

  protected:

    //## Other Operations (specified)
      //## Operation: sync%38988EA672E0
      virtual int sync ();

      //## Operation: overflow%38988ECCD6C0
      virtual int overflow (int c = EOF);

      //## Operation: setbuf%38AC2246FAE0; C++
      //	Allow for buffered or unbuffered input in either
      //	direction, so that  buffering strategies can be changed
      //	later as expedient.
      //
      //	The sign of n is used to denote output (+ve) or input
      //	(-ve).
      //
      //	Unbuffered input needs extra functions pbackfail and
      //	data   members char ch, bool fromBuf.
      //
      //	See Langer & Kreft 2000, Standard C++ IOStreams and
      //	Locales, Sec 3.4
      virtual std::streambuf* setbuf (char* s, std::streamsize n);

      //## Operation: uflow%38BEB7500668
      virtual int uflow ();

      //## Operation: underflow%38BEB82C2D10
      virtual int underflow ();

      //## Operation: pbackfail%38C95759CCE8
      int pbackfail (int c = EOF);

  private:
    //## Constructors (generated)
      XSstreambuf(const XSstreambuf &right);

    //## Assignment Operation (generated)
      XSstreambuf & operator=(const XSstreambuf &right);


    //## Other Operations (specified)
      //## Operation: fillBuffer%38CD0FD98AC0
      int fillBuffer ();

      //## Operation: bufferOut%3BA661C6015E
      std::streamsize bufferOut ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: unbuffered%38C972BBD090
      const bool unbuffered () const;
      void unbuffered (bool value);

      //## Attribute: charTaken%38C972D3DEE0
      const bool charTaken () const;
      void charTaken (bool value);

      //## Attribute: ch%38C9730B4568
      const char ch () const;
      void ch (char value);

      //## Attribute: pbChars%38CD194522A8
      //	Data member to support a putback facility.
      //
      //	putback is probably totally irrelevant to this
      //	application,
      //	but is implemented for generality.
      const int pbChars () const;
      void pbChars (int value);

      //## Attribute: bufLen%38D28CB41720
      const std::streamsize bufLen () const;
      void bufLen (std::streamsize value);

    //## Get and Set Operations for Associations (generated)

      //## Association: XSUser::UserInterface::<unnamed>%38988AAB6188
      //## Role: XSstreambuf::channel%38988AAC8CD0
      XSchannel* channel ();

  private: //## implementation
    // Data Members for Class Attributes

      //## begin XSstreambuf::unbuffered%38C972BBD090.attr preserve=no  private: bool {U} false
      bool m_unbuffered;
      //## end XSstreambuf::unbuffered%38C972BBD090.attr

      //## begin XSstreambuf::charTaken%38C972D3DEE0.attr preserve=no  private: bool {U} false
      bool m_charTaken;
      //## end XSstreambuf::charTaken%38C972D3DEE0.attr

      //## begin XSstreambuf::ch%38C9730B4568.attr preserve=no  private: char {U} '\0'
      char m_ch;
      //## end XSstreambuf::ch%38C9730B4568.attr

      //## begin XSstreambuf::pbChars%38CD194522A8.attr preserve=no  private: int {U} 4
      int m_pbChars;
      //## end XSstreambuf::pbChars%38CD194522A8.attr

      //## begin XSstreambuf::bufLen%38D28CB41720.attr preserve=no  private: std::streamsize {U} 0
      std::streamsize m_bufLen;
      //## end XSstreambuf::bufLen%38D28CB41720.attr

      //## Attribute: buffer%496B9B40039A
      //## begin XSstreambuf::buffer%496B9B40039A.attr preserve=no  private: char* {U} 0
      char* m_buffer;
      //## end XSstreambuf::buffer%496B9B40039A.attr

    // Data Members for Associations

      //## Association: XSUser::UserInterface::<unnamed>%38988AAB6188
      //## begin XSstreambuf::channel%38988AAC8CD0.role preserve=no  private: XSchannel { -> 1..1RFHgN}
      XSchannel* m_channel;
      //## end XSstreambuf::channel%38988AAC8CD0.role

  //## begin XSstreambuf%3898889BE8F0.friends preserve=no
    friend class XSstream;
  //## end XSstreambuf%3898889BE8F0.friends
};

//## begin XSstream%389887EE8DE0.preface preserve=yes
//## end XSstream%389887EE8DE0.preface

//## Class: XSstream%389887EE8DE0
//	An XSstream object OWNS its dynamically allocated
//	XSstreambuf, and therefore must delete it in its
//	destructor.  (This is not the case with a standard basic_
//	ios and its streambuf.)
//## Category: XSUtil::Utils%370B67146E50
//## Subsystem: XSUtil::Utils%3777E01D9D80
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3B9697D3025F;friend XSstreambuf { -> }
//## Uses: <unnamed>%3B9D1235006E;XSchannel { -> F}

class XSstream : public std::iostream  //## Inherits: <unnamed>%38CD29694378
{
  //## begin XSstream%389887EE8DE0.initialDeclarations preserve=yes
  //## end XSstream%389887EE8DE0.initialDeclarations

  public:
    //## Class: NotXSstream%3BA0DCFA002A
    //## Category: XSUtil::Utils%370B67146E50
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NotXSstream : public YellowAlert  //## Inherits: <unnamed>%3BA0DD57003B
    {
      public:
        //## Constructors (generated)
          NotXSstream();

      protected:
      private:
      private: //## implementation
    };

    //## Constructors (generated)
      XSstream();

    //## Constructors (specified)
      //## Operation: XSstream%389894081AD0
      //	Stream with an XSchannel object.
      XSstream (XSchannel* chan, std::streamsize bufferLen = bufSize);

    //## Destructor (generated)
      virtual ~XSstream();


    //## Other Operations (specified)
      //## Operation: setPrompter%38D29178A0F0
      //	setPrompter hands to input stream s the prompt
      //	ps, which can be a script or a text prompt depending
      //	on the context. BY CONVENTION, all text prompts
      //	must end in ">" or ":" or they will be assumed to be
      //	script names. This version is to be used for
      //	scripts that do not take a vector of arguments.
      //
      //	setPrompter is static and virtual: this allows the
      //	first (istream&) argument to be cast inside the
      //	function and thus allow the stream to look like a
      //	"normal" istream.
      //
      //	The virtualness allows a default implementation to
      //	exist even for channel classes that don't use it,
      //	to allow compilation to proceed.
      static void setPrompter (std::istream& s, const std::string& ps = ">");

      //## Operation: setPrompter%38E2741F5320
      //	The overloaded versions of setPrompter with signature
      //
      //	(istream&, const string&, const vector<string>&, const
      //	vector<string>&)
      //
      //	Provide the facility for the internal code to send
      //	strings to a script that describes a dialog box.
      //
      //	Typically it might be used to provide prompt strings
      //	and information strings to the script ps.
      //
      //	This concept can be used for the command line
      //	interface too, if it is desired to make the dialogue
      //	with the user a single function call that returns
      //	a set of strings (as will the GUI).
      //
      //	The setPrompter function, which chains into the
      //	channel implementation through the streambuf is
      //	of static void type.
      static void setPrompter (std::istream& s, const std::string& ps, const std::vector<std::string>& prompts, const std::vector<std::string>& infos);

      //## Operation: setLogger%3B966AE80274
      void setLogger (const std::string& name = "xspec.log", bool isErr = false);

      //## Operation: closeLog%3B968DF2032C
      void closeLog ();

      //## Operation: verbose%3BA0D84A035A
      static void verbose (XSstream& s, int con = -1, int log = -1);

      //## Operation: defineChannel%3BA20DBF010E
      static void defineChannel (std::ostream& s, XSchannel* chan, std::streamsize bufLen = 0);

      //## Operation: defineChannel%3BA2126E03CE
      static void defineChannel (std::istream& s, XSchannel* chan, std::streamsize bufLen = 0);

      //## Operation: maxChatter%3F32698F02CF
      int maxChatter ();

      //## Operation: getChannel%424ACD6A037A
      XSchannel* getChannel ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: conVerbose%3BA209F10230
      int conVerbose () const;

      //## Attribute: logVerbose%3BA20A040280
      int logVerbose () const;

      //## Attribute: consoleChatterLevel%3E8C7A0A0332
      const int consoleChatterLevel () const;
      void consoleChatterLevel (int value);

      //## Attribute: logChatterLevel%3E8C7A0F00D5
      const int logChatterLevel () const;
      void logChatterLevel (int value);

  public:
    // Additional Public Declarations
      //## begin XSstream%389887EE8DE0.public preserve=yes
      //## end XSstream%389887EE8DE0.public

  protected:
    // Additional Protected Declarations
      //## begin XSstream%389887EE8DE0.protected preserve=yes
      //## end XSstream%389887EE8DE0.protected

  private:
    //## Constructors (generated)
      XSstream(const XSstream &right);

    //## Assignment Operation (generated)
      XSstream & operator=(const XSstream &right);


    //## Other Operations (specified)
      //## Operation: defineChannel%38B697943F90
      void defineChannel (XSchannel* chan, std::streamsize bufLen = 0);

      //## Operation: setVerboseLevel%3B9D0DAE03BC
      void setVerboseLevel (int console, int log);

    // Additional Private Declarations
      //## begin XSstream%389887EE8DE0.private preserve=yes
      //## end XSstream%389887EE8DE0.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin XSstream::conVerbose%3BA209F10230.attr preserve=no  public: int {U} 
      int m_conVerbose;
      //## end XSstream::conVerbose%3BA209F10230.attr

      //## begin XSstream::logVerbose%3BA20A040280.attr preserve=no  public: int {U} 
      int m_logVerbose;
      //## end XSstream::logVerbose%3BA20A040280.attr

      //## begin XSstream::consoleChatterLevel%3E8C7A0A0332.attr preserve=no  public: int {U} NORM_OUTPUT
      int m_consoleChatterLevel;
      //## end XSstream::consoleChatterLevel%3E8C7A0A0332.attr

      //## begin XSstream::logChatterLevel%3E8C7A0F00D5.attr preserve=no  public: int {U} 
      int m_logChatterLevel;
      //## end XSstream::logChatterLevel%3E8C7A0F00D5.attr

    // Additional Implementation Declarations
      //## begin XSstream%389887EE8DE0.implementation preserve=yes
      //## end XSstream%389887EE8DE0.implementation

};

//## begin XSstream%389887EE8DE0.postscript preserve=yes
//## end XSstream%389887EE8DE0.postscript

//## begin XSchannel%389888C147C0.preface preserve=yes
//## end XSchannel%389888C147C0.preface

//## Class: XSchannel%389888C147C0
//## Category: XSUtil::Utils%370B67146E50
//## Subsystem: XSUtil::Utils%3777E01D9D80
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3B9D14C903E3;XSstreambuf { -> F}

class XSchannel 
{
  //## begin XSchannel%389888C147C0.initialDeclarations preserve=yes
  //## end XSchannel%389888C147C0.initialDeclarations

  public:
    //## Class: LogFileOpenFailure%3B969CBE0360
    //## Category: XSUtil::Utils%370B67146E50
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class LogFileOpenFailure : public YellowAlert  //## Inherits: <unnamed>%3B969D5500F0
    {
      public:
        //## Constructors (specified)
          //## Operation: LogFileOpenFailure%3B969CD903A1
          LogFileOpenFailure (const std::string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Destructor (generated)
      virtual ~XSchannel();


    //## Other Operations (specified)
      //## Operation: read%38988CAC86F8
      //	Abstract read function for tcl channels.
      //
      //	The int returned will be the number of characters
      //	successfully read by tcl.
      //
      //	Desire here is to implement logging for
      //	the CLI version, handled in subclass TclIO.
      //
      //	The TkIO version will read input from a graphical
      //	window and will thus need a (tk) script name to prompt
      //	user. In this sense the tk GUI occupies the same
      //	function as the CLI prompt.
      //
      //	The read,write functions follow the Unix O/S convention
      //	for return codes: they return 0, -1 as the read, write
      //	was successful or unsuccessful.
      virtual std::streamsize read (char* s, std::streamsize n = 1) = 0;

      //## Operation: setPrompt%38D2B151FD98
      virtual void setPrompt (const std::string& ps);

      //## Operation: prompts%38E272296B48
      virtual void prompts (const std::string& script, const std::vector<std::string>& prompts, const std::vector<std::string>& infos);

      //## Operation: setLogger%3B966E970121
      void setLogger (const std::string& name, bool isErr = false);

      //## Operation: closeLog%3B968E3B0330
      void closeLog ();

      //## Operation: toDevice%3BA666A30212
      int toDevice (const char* s, std::streamsize n);

  public:
    // Additional Public Declarations
      //## begin XSchannel%389888C147C0.public preserve=yes
      //friend void XSstreambuf::setChannel(XSchannel* channel, std::streamsize bufferLen, XSstream* parent);
      friend class XSstreambuf;            
      //## end XSchannel%389888C147C0.public
  protected:
    //## Constructors (generated)
      XSchannel();


    //## Other Operations (specified)
      //## Operation: logVerbose%3B9D160600E9
      size_t logVerbose () const;

      //## Operation: conVerbose%3B9D16260319
      size_t conVerbose () const;

    //## Get and Set Operations for Associations (generated)

      //## Association: <unnamed>%3BA0E03F0129
      //## Role: XSchannel::stream%3BA0E04100E4
      const XSstream* stream () const;
      void stream (XSstream* value);

    // Additional Protected Declarations
      //## begin XSchannel%389888C147C0.protected preserve=yes
      //## end XSchannel%389888C147C0.protected

  private:

    //## Other Operations (specified)
      //## Operation: write%38988CC2D308
      //	write will call Tcl_Write in the case of
      //	the CLI version, and a tk window pathname in the case of
      //	the GUI.
      //
      //	Logging will be implemented in the case of CLI.
      //
      //	The read,write functions follow the Unix O/S convention
      //	for return codes: they return 0, -1 as the read, write
      //	was successful or unsuccessful.
      virtual std::streamsize write (const char *s, std::streamsize n) = 0;

      //## Operation: internalSetLogger%3B966EBB019F
      virtual void internalSetLogger (const std::string& name, bool isErr = false) = 0;

      //## Operation: internalCloseLog%3B968E110330
      virtual void internalCloseLog () = 0;

    // Additional Private Declarations
      //## begin XSchannel%389888C147C0.private preserve=yes
      //## end XSchannel%389888C147C0.private

  private: //## implementation
    // Data Members for Associations

      //## Association: <unnamed>%3BA0E03F0129
      //## begin XSchannel::stream%3BA0E04100E4.role preserve=no  protected: XSstream { -> 1RFHgN}
      XSstream* m_stream;
      //## end XSchannel::stream%3BA0E04100E4.role

    // Additional Implementation Declarations
      //## begin XSchannel%389888C147C0.implementation preserve=yes
      //## end XSchannel%389888C147C0.implementation

};

//## begin XSchannel%389888C147C0.postscript preserve=yes
//## end XSchannel%389888C147C0.postscript

// Class XSstreambuf 

//## Get and Set Operations for Class Attributes (inline)

inline const bool XSstreambuf::unbuffered () const
{
  //## begin XSstreambuf::unbuffered%38C972BBD090.get preserve=no
  return m_unbuffered;
  //## end XSstreambuf::unbuffered%38C972BBD090.get
}

inline void XSstreambuf::unbuffered (bool value)
{
  //## begin XSstreambuf::unbuffered%38C972BBD090.set preserve=no
  m_unbuffered = value;
  //## end XSstreambuf::unbuffered%38C972BBD090.set
}

inline const bool XSstreambuf::charTaken () const
{
  //## begin XSstreambuf::charTaken%38C972D3DEE0.get preserve=no
  return m_charTaken;
  //## end XSstreambuf::charTaken%38C972D3DEE0.get
}

inline void XSstreambuf::charTaken (bool value)
{
  //## begin XSstreambuf::charTaken%38C972D3DEE0.set preserve=no
  m_charTaken = value;
  //## end XSstreambuf::charTaken%38C972D3DEE0.set
}

inline const char XSstreambuf::ch () const
{
  //## begin XSstreambuf::ch%38C9730B4568.get preserve=no
  return m_ch;
  //## end XSstreambuf::ch%38C9730B4568.get
}

inline void XSstreambuf::ch (char value)
{
  //## begin XSstreambuf::ch%38C9730B4568.set preserve=no
  m_ch = value;
  //## end XSstreambuf::ch%38C9730B4568.set
}

inline const int XSstreambuf::pbChars () const
{
  //## begin XSstreambuf::pbChars%38CD194522A8.get preserve=no
  return m_pbChars;
  //## end XSstreambuf::pbChars%38CD194522A8.get
}

inline void XSstreambuf::pbChars (int value)
{
  //## begin XSstreambuf::pbChars%38CD194522A8.set preserve=no
  m_pbChars = value;
  //## end XSstreambuf::pbChars%38CD194522A8.set
}

inline const std::streamsize XSstreambuf::bufLen () const
{
  //## begin XSstreambuf::bufLen%38D28CB41720.get preserve=no
  return m_bufLen;
  //## end XSstreambuf::bufLen%38D28CB41720.get
}

inline void XSstreambuf::bufLen (std::streamsize value)
{
  //## begin XSstreambuf::bufLen%38D28CB41720.set preserve=no
  m_bufLen = value;
  //## end XSstreambuf::bufLen%38D28CB41720.set
}

//## Get and Set Operations for Associations (inline)

inline XSchannel* XSstreambuf::channel ()
{
  //## begin XSstreambuf::channel%38988AAC8CD0.get preserve=no
  return m_channel;
  //## end XSstreambuf::channel%38988AAC8CD0.get
}

// Class XSstream::NotXSstream 

// Class XSstream 

//## Get and Set Operations for Class Attributes (inline)

inline int XSstream::conVerbose () const
{
  //## begin XSstream::conVerbose%3BA209F10230.get preserve=no
  return m_conVerbose;
  //## end XSstream::conVerbose%3BA209F10230.get
}

inline int XSstream::logVerbose () const
{
  //## begin XSstream::logVerbose%3BA20A040280.get preserve=no
  return m_logVerbose;
  //## end XSstream::logVerbose%3BA20A040280.get
}

inline const int XSstream::consoleChatterLevel () const
{
  //## begin XSstream::consoleChatterLevel%3E8C7A0A0332.get preserve=no
  return m_consoleChatterLevel;
  //## end XSstream::consoleChatterLevel%3E8C7A0A0332.get
}

inline void XSstream::consoleChatterLevel (int value)
{
  //## begin XSstream::consoleChatterLevel%3E8C7A0A0332.set preserve=no
  m_consoleChatterLevel = value;
  //## end XSstream::consoleChatterLevel%3E8C7A0A0332.set
}

inline const int XSstream::logChatterLevel () const
{
  //## begin XSstream::logChatterLevel%3E8C7A0F00D5.get preserve=no
  return m_logChatterLevel;
  //## end XSstream::logChatterLevel%3E8C7A0F00D5.get
}

inline void XSstream::logChatterLevel (int value)
{
  //## begin XSstream::logChatterLevel%3E8C7A0F00D5.set preserve=no
  m_logChatterLevel = value;
  //## end XSstream::logChatterLevel%3E8C7A0F00D5.set
}

// Class XSchannel::LogFileOpenFailure 

// Class XSchannel 

//## Get and Set Operations for Associations (inline)

inline const XSstream* XSchannel::stream () const
{
  //## begin XSchannel::stream%3BA0E04100E4.get preserve=no
  return m_stream;
  //## end XSchannel::stream%3BA0E04100E4.get
}

inline void XSchannel::stream (XSstream* value)
{
  //## begin XSchannel::stream%3BA0E04100E4.set preserve=no
  m_stream = value;
  //## end XSchannel::stream%3BA0E04100E4.set
}

//## begin module%38CD1AF57320.epilog preserve=yes
//## end module%38CD1AF57320.epilog


#endif
